--addon name, addon namespace
local _, ans = ...;
local isFrameExist = ans.isFrameExist;
local kdoUiFrameName = "KdoUiMainFrame";

local region = GetCurrentRegion();
local realmName = GetRealmName();
local battleTag = select(2, BNGetInfo());
if (not region) then region = "region"  end;
if (not realmName) then realmName = "realmName"  end;
if (not battleTag) then battleTag = "battleTag"  end;
local accountId = region..realmName..battleTag;
ans.isMyAccount = accountId:match("^3SargerasKdo2noel");

if (not KdoUiData) then
    KdoUiData = {
        MicroButtonAndBagsBarOnLeft = false,
        ShowMicroButtonAndBagsBarOnHover = true,
        ShowMainMenuBarOnHover = false,
        ShowMultiBarBottomLeftOnHover = false,
        ShowMultiBarBottomRightOnHover = false,
        ShowMultiBarRightOnHover = false,
        ShowMultiBarLeftOnHover = false,
        ShowMultiBar5OnHover = false,
        ShowMultiBar6OnHover = false,
        ShowMultiBar7OnHover = false,
        ShowStanceBarHover = false,
        ShowPetActionBarHover = false
    };
end

if  (not isFrameExist(kdoUiFrameName)) then
    local frame = CreateFrame("Frame", kdoUiFrameName);
    frame:RegisterEvent("PLAYER_ENTERING_WORLD");
    
    local function onEvent(self, event, ...)
        if (event == "PLAYER_ENTERING_WORLD") then
            local initialLogin, reloadingUI = ...;
            if (initialLogin or reloadingUI) then

                -- Hide CompactPartyFrames name and update scale, Show 5 buffs and debuffs
                if (ans.isMyAccount) then
                    ans.CompactUnitFrameAuras_laod();
                end

                -- Show MultiBarRight and MultiBarLeft on hover
                ans.ActionBars_load();

                -- Show chat buttons on hover
                ans.Chat_load();

                -- Make bags and micro buttons visible on hover
                ans.MicroButtons_load();

                -- Move tooltip status bar on top
                ans.Tooltip_load();

                -- Style unit frames with class color
                ans.UnitFrames_load();

                -- Add addon settings in the blizzard interface
                ans.Settings_load();

                self:UnregisterAllEvents();
            end
        end
    end

    frame:SetScript("OnEvent", onEvent);
end

-- To show interface errors logs use /console taintlog 1
-- Logs are in World of Warcraft/Logs/taint.log